<?php
/*
Plugin Name: WP Users Page
Plugin URI: http://www.capn3m0.org/wp-users-page/
Description: Wp Users Page allow you to create a page with pics,description,name and role of any wp users simply adding tag [wpuserspage role=\"<role name>\"] into a new page or post.
Version: 0.1
Author: capn3m0 <capn3m0@capn3m0.org>
Author URI: http://www.capn3m0.org
License: GPL2

=== RELEASE NOTES ===
2011-05-07 - v0.1 - first version

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
*/
            function wpuserspage($atts) {
			global $wpdb;
			//acquire role parameter
			$role = $atts['role'];
			//select all the user id having this role
			$query = "SELECT ID FROM ".$wpdb->prefix."users INNER JOIN ".$wpdb->prefix."usermeta WHERE ".$wpdb->prefix."usermeta.meta_value LIKE '%".$role."%'  AND ".$wpdb->prefix."usermeta.meta_key ='wp_capabilities' AND ".$wpdb->prefix."usermeta.user_id = ".$wpdb->prefix."users.ID";
			$UserID = $wpdb->get_results($query);
			$max = sizeof($UserID);
			echo '<div>';
			//for each id retrieve userinformation and print
			for($i=0;$i<=$max-1;$i++)
			{
				$uid = $UserID[$i]->ID;
				$user = get_userdata( $uid );
				$name = $user->display_name;
				$username = $user->user_login;
				$email = $user->email;
				$desc = $user->description;
				$fq = get_avatar($uid);
				$current_link = get_author_posts_url($uid);
				echo "<table border=\"0\" width=\"100%\" height=\"50px\">
				<tbody>
				<tr>
				<td width=\"75%\" valign=\"top\">
				<strong><a href=\"$current_link\">$name</a></strong> ($role)</td>
				<td align=\"center\">";
				echo get_avatar($uid);
				echo "</td>
				</tr>
				<tr>
				<td colspan=\"2\" valign=\"middle\">$desc</td>
				</tr>
				</tbody>
				</table>";
			}
			echo "</div>";
			}

			function atlas_clean_shortcode_content( $content ) {
			/* Parse nested shortcodes and add formatting. */
			$content = trim( wpautop( do_shortcode( $content ) ) );
			/* Remove '</p>' from the start of the string. */
			if ( substr( $content, 0, 4 ) == '</p>' )
			$content = substr( $content, 4 );
			/* Remove '<p>' from the end of the string. */
			if ( substr( $content, -3, 3 ) == '<p>' )
			$content = substr( $content, 0, -3 );
			/* Remove any instances of '<p></p>'. */
			$content = str_replace( array( '<p></p>' ), '', $content );
			return $content;
			}

			
//register the Shortcode handler			
add_shortcode( 'wpuserspage', 'wpuserspage' );

?>